#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

/* 
 * Stworzenie struktury ktra zawiera typ wiadomoci i tre
 */
typedef struct {
   long type;
   char body[100];
} msg;

int main(){
   int id;
   int result;
   msg wiad; // tworzenie zmiennej ktra bdzie wysyana
   wiad.type = 100; // Ustawienie typu wiadomoci na 100 - ten 
 //   typ programista wymyla sam - przydaje si to kiedy midzy programami
 //   jest wysyanych wiele wiadomoci o rnym przeznaczeniu
   strcpy(wiad.body, "Hello World test"); // Wstawienie napisu do treci 
   // wiadomoci
   id = msgget(1642, IPC_CREAT | 0666); // stworzenie kolejki z
   // uprawnieniami odczytu i zapisu dla wszystkich
   if(id < 0){ // jeli kana nie zosta utworzony - id <0 - wywietl komunikat
      // i zakocz dziaanie programu
      printf("Msgget: %d\n", id);
      exit(1);
   }
   result = msgsnd(id, &wiad, strlen(wiad.body), 0); // wysyanie wiadomoci
   wiad.type = 101;
   strcpy(wiad.body, "Inny test 101");
   result = msgsnd(id, &wiad, strlen(wiad.body), 0);
   wiad.type = 102;
   strcpy(wiad.body, "Inny test 102");
   result = msgsnd(id, &wiad, strlen(wiad.body), 0);
   wiad.type = 103;
   strcpy(wiad.body, "Inny test 103");
   result = msgsnd(id, &wiad, strlen(wiad.body), 0);
   printf("%d\n", result); // wywietlenie komunikatu o wyniku wysania
   return 0;
}
